SEM_WAIT(3)

NAME
sem_wait, sem_trywait - decrement (lock) a semaphore

LIBRARY
libc

SYNOPSIS
#include <semaphore.h>
int
sem_wait(sem_t *sem);
int
sem_trywait(sem_t *sem);

DESCRIPTION
The sem_wait() function decrements (locks) the semaphore pointed to by sem, but blocks if the value of sem is zero, until the value is non-zero and the value can be decremented.

The sem_trywait() function decrements (locks) the semaphore pointed to by sem only if the value is non-zero. Otherwise, the semaphore is not decremented and an error is returned.

RETURN VALUES

ERRORS
The sem_wait() and sem_trywait() functions will fail if:

[EINVAL]
    The sem argument points to an invalid semaphore.

Additionally, sem_trywait() will fail if:

[EAGAIN]
    The semaphore value was zero, and thus could not be decremented.

SEE ALSO
sem_getvalue(3), sem_post(3), sem_timedwait(3), sem(4)

STANDARDS
The sem_wait() and sem_trywait() functions conform to p1003.1-96.